=== debian/changelog ===
libical (1.0-0ubuntu1) saucy; urgency=low

  * New upstream release
  * Remove patched now upstream
   - 0001_convert_float_to_strings_with_snprintf_sfbug3493034.patch
   - fix_arm_ftbfs.patch
   - fix_ftbfs_dependencies.patch

 -- Jonathan Riddell <jriddell@ubuntu.com>  Tue, 11 Jun 2013 15:29:40 +0100
