=== debian/control ===
Source: libical
Section: libs
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Fathi Boudra <fabo@debian.org>
Build-Depends: debhelper (>= 9), cmake, tzdata
Standards-Version: 3.9.3
Homepage: http://freeassociation.sourceforge.net

Package: libical-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libical1 (= ${binary:Version})
Description: iCalendar library implementation in C (development)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.

Package: libical1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, tzdata
Description: iCalendar library implementation in C (runtime)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.
 .
 This package contains the files necessary for running applications that use
 the libical library.

Package: libical-dbg
Priority: extra
Architecture: any
Section: debug
Depends: libical1 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for libical
 This package contains the debugging symbols associated with libical.
 .
 They will automatically be used by gdb for debugging libical related issues.
