=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake --parallel --list-missing --dbg-package=libical-dbg
