## libical 1.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,15 +18,21 @@
 # -DICAL_UNIX_NEWLINE=[true|false]
 #  Set to terminate each line with the RFC2445 specified line terminator "\\n";
 #  else it will terminate lines with "\\n\\r"
-#  Default=true
+#  Default=true (on non-Windows systems; else false)
 #
 # -DUSE_BUILTIN_TZDATA=[true|false]
 #  Set to build using our own timezone data.
-#  Default=false (use the system timezone data)
-#
-# -DSTATIC_LIBRARY=[true|false]
+#  Default=false (use the system timezone data on non-Windows systems)
+#  ALWAYS true on Windows systems
+#
+# -DSTATIC_ONLY=[true|false]
 #  Set to build static libraries only.
 #  Default=false (build shared and static libs)
+#
+# -DSHARED_ONLY=[true|false]
+#  Set to build shared (dynamic) libraries only.
+#  Default=false (build shared and static libs)
+#  Takes precedence over STATIC_ONLY
 #
 # -DGOBJECT_INTROSPECTION=[true|false]
 #  Set to build GObject introspection "typelib" files
@@ -38,13 +44,14 @@
 #  Default=false (use the default size of time_t)
 #
 
-project(libical)
-
-cmake_minimum_required(VERSION 2.4)
+cmake_minimum_required(VERSION 2.8.9)
+
+project(libical C CXX)
+
 if(COMMAND cmake_policy)
   cmake_policy(SET CMP0003 NEW)
   cmake_policy(SET CMP0005 OLD)
-endif(COMMAND cmake_policy)
+endif()
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 
@@ -55,25 +62,34 @@
   include_directories(${WCECOMPAT_INCLUDE_DIR})
   set(CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${WCECOMPAT_INCLUDE_DIR})
   set(CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES} ${WCECOMPAT_LIBRARIES})
-endif(WINCE)
+endif()
 
 set(LIBICAL_LIB_MAJOR_VERSION "1")
 set(LIBICAL_LIB_MINOR_VERSION "0")
-set(LIBICAL_LIB_PATCH_VERSION "0")
+set(LIBICAL_LIB_PATCH_VERSION "1")
 set(LIBICAL_LIB_VERSION_STRING
   "${LIBICAL_LIB_MAJOR_VERSION}.${LIBICAL_LIB_MINOR_VERSION}.${LIBICAL_LIB_PATCH_VERSION}"
 )
 
 set(PROJECT_VERSION "${LIBICAL_LIB_MAJOR_VERSION}.${LIBICAL_LIB_MINOR_VERSION}")
-set(PROJECT_URL "http://freeassociation.sf.net/")
-
-if(STATIC_LIBRARY)
+set(PROJECT_URL "http://libical.github.io/libical/")
+
+# library build types
+set(LIBICAL_STATIC 0)
+set(LIBRARY_TYPE SHARED)
+
+if(STATIC_ONLY)
   set(LIBICAL_STATIC 1)
   add_definitions(-DLIBICAL_STATIC)
   set(LIBRARY_TYPE STATIC)
-else(STATIC_LIBRARY)
+endif()
+
+if(SHARED_ONLY)
+  set(STATIC_ONLY False)
+  set(LIBICAL_STATIC 0)
+  remove_definitions(-DLIBICAL_STATIC)
   set(LIBRARY_TYPE SHARED)
-endif(STATIC_LIBRARY)
+endif()
 
 # must have Perl to create the derived stuff
 find_package(Perl REQUIRED)
@@ -84,10 +100,10 @@
     add_definitions(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -DYY_NO_UNISTD_H)
     if(USE_32BIT_TIME_T)
       add_definitions(-D_USE_32BIT_TIME_T)
-    endif(USE_32BIT_TIME_T)
-  endif(MSVC)
+    endif()
+  endif()
   add_definitions(-DBIG_ENDIAN=0 -DLITTLE_ENDIAN=1 -DBYTE_ORDER=BIG_ENDIAN)
-endif(WIN32)
+endif()
 
 set(LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)")
 set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Library directory name" FORCE)
@@ -100,63 +116,72 @@
   set(LIBRARY_OUTPUT_PATH ${EXECUTABLE_OUTPUT_PATH})
   set(LIB_INSTALL_DIR lib)
   set(BIN_INSTALL_DIR bin)
-else(WIN32)
+else()
   set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)
-endif(WIN32)
+endif()
 
 if(APPLE)
   set(CMAKE_INSTALL_NAME_DIR ${LIB_DESTINATION})
-endif(APPLE)
+endif()
 
 if(NOT DEFINED ICAL_ERRORS_ARE_FATAL)
   set(ICAL_ERRORS_ARE_FATAL 0)
-else(NOT DEFINED ICAL_ERRORS_ARE_FATAL)
+else()
   if(ICAL_ERRORS_ARE_FATAL)
     set(ICAL_ERRORS_ARE_FATAL 1)
-  else(ICAL_ERRORS_ARE_FATAL)
+  else()
     set(ICAL_ERRORS_ARE_FATAL 0)
-  endif(ICAL_ERRORS_ARE_FATAL)
-endif(NOT DEFINED ICAL_ERRORS_ARE_FATAL)
+  endif()
+endif()
 
 if(NOT DEFINED ICAL_UNIX_NEWLINE)
-  set(ICAL_UNIX_NEWLINE 1)
-else(NOT DEFINED ICAL_UNIX_NEWLINE)
+  if(WIN32 OR WINCE)
+    set(ICAL_UNIX_NEWLINE 0)
+  else()
+    set(ICAL_UNIX_NEWLINE 1)
+  endif()
+else()
   if(ICAL_UNIX_NEWLINE)
     set(ICAL_UNIX_NEWLINE 1)
-  else(ICAL_UNIX_NEWLINE)
+  else()
     set(ICAL_UNIX_NEWLINE 0)
-  endif(ICAL_UNIX_NEWLINE)
-endif(NOT DEFINED ICAL_UNIX_NEWLINE)
+  endif()
+endif()
 
 if(NOT DEFINED ICAL_ALLOW_EMPTY_PROPERTIES)
   set(ICAL_ALLOW_EMPTY_PROPERTIES 0)
-else(NOT DEFINED ICAL_ALLOW_EMPTY_PROPERTIES)
+else()
   if(ICAL_ALLOW_EMPTY_PROPERTIES)
     set(ICAL_ALLOW_EMPTY_PROPERTIES 1)
-  else(ICAL_ALLOW_EMPTY_PROPERTIES)
+  else()
     set(ICAL_ALLOW_EMPTY_PROPERTIES 0)
-  endif(ICAL_ALLOW_EMPTY_PROPERTIES)
-endif(NOT DEFINED ICAL_ALLOW_EMPTY_PROPERTIES)
+  endif()
+endif()
 
 if(NOT DEFINED NO_WARN_DEPRECATED)
   set(NO_WARN_DEPRECATED 1)
-else(NOT DEFINED NO_WARN_DEPRECATED)
+else()
   if(NO_WARN_DEPRECATED)
     set(NO_WARN_DEPRECATED 1)
-  else(NO_WARN_DEPRECATED)
+  else()
     set(NO_WARN_DEPRECATED 0)
-  endif(NO_WARN_DEPRECATED)
-endif(NOT DEFINED NO_WARN_DEPRECATED)
+  endif()
+endif()
 
 if(NOT DEFINED USE_BUILTIN_TZDATA)
   set(USE_BUILTIN_TZDATA 0)
-else(NOT DEFINED USE_BUILTIN_TZDATA)
+else()
   if(USE_BUILTIN_TZDATA)
     set(USE_BUILTIN_TZDATA 1)
-  else(USE_BUILTIN_TZDATA)
+  else()
     set(USE_BUILTIN_TZDATA 0)
-  endif(USE_BUILTIN_TZDATA)
-endif(NOT DEFINED USE_BUILTIN_TZDATA)
+  endif()
+endif()
+#Always use builtin tzdata on Windows systems.
+if(WIN32 OR WINCE)
+  message(STATUS "Currently unable to use system tzdata on Windows. Falling back to builtin tzdata")
+  set(USE_BUILTIN_TZDATA 1)
+endif()
 
 include(ConfigureChecks.cmake)
 add_definitions(-DHAVE_CONFIG_H)
@@ -173,10 +198,47 @@
   find_package(GObjectIntrospection ${MIN_GOBJECT_INTROSPECTION})
   if(INTROSPECTION_FOUND)
     set(HAVE_INTROSPECTION TRUE)
-  else(INTROSPECTION_FOUND)
+  else()
     message(FATAL_ERROR "You requested to build with GObject Introspection but the necessary development package is missing or too low a version (version ${MIN_GOBJECT_INTROSPECTION} or higher is required)")
-  endif(INTROSPECTION_FOUND)
-endif(GOBJECT_INTROSPECTION)
+  endif()
+endif()
+
+#
+# Compiler settings
+#
+if(CMAKE_COMPILER_IS_GNUCC OR "${CMAKE_C_COMPILER_ID}" STREQUAL "Clang")
+  include(CheckCCompilerFlag)
+  check_c_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
+  check_c_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
+  check_c_compiler_flag(-Wsizeof-pointer-memaccess HAVE_GCC_POINTER_MEMACCESS)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-deprecated -Wall -Wextra -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Werror=return-type")
+  if(HAVE_GCC_UNUSED_BUT_SET)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wunused-but-set-variable")
+  endif()
+  if(HAVE_GCC_LOGICAL_OP)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wlogical-op")
+  endif()
+  if(HAVE_GCC_POINTER_MEMACCESS)
+    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wsizeof-pointer-memaccess")
+  endif()
+endif()
+
+if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
+  include(CheckCXXCompilerFlag)
+  check_cxx_compiler_flag(-Wunused-but-set-variable HAVE_GCC_UNUSED_BUT_SET)
+  check_cxx_compiler_flag(-Wlogical-op HAVE_GCC_LOGICAL_OP)
+  check_cxx_compiler_flag(-Wsizeof-pointer-memaccess HAVE_GCC_POINTER_MEMACCESS)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated -Wall -Wextra -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wno-div-by-zero -Wundef -Wpointer-arith -Werror=return-type")
+  if(HAVE_GCC_UNUSED_BUT_SET)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wunused-but-set-variable")
+  endif()
+  if(HAVE_GCC_LOGICAL_OP)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
+  endif()
+  if(HAVE_GCC_POINTER_MEMACCESS)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsizeof-pointer-memaccess")
+  endif()
+endif()
 
 ################# build subdirs ########################
 
@@ -189,7 +251,7 @@
 if(USE_BUILTIN_TZDATA)
   # use our zoneinfo if cmake is passed -DUSE_BUILTIN_TZDATA
   add_subdirectory(zoneinfo)
-endif(USE_BUILTIN_TZDATA)
+endif()
 
 ########### create and install pkg-config file #########
 
@@ -202,3 +264,30 @@
 
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libical.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libical.pc @ONLY)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libical.pc DESTINATION ${LIB_INSTALL_DIR}/pkgconfig)
+
+########### Create and install the CMake Config files ##########
+include(CMakePackageConfigHelpers)
+
+configure_package_config_file(
+  LibIcalConfig.cmake.in ${libical_BINARY_DIR}/LibIcalConfig.cmake
+  INSTALL_DESTINATION ${LIB_INSTALL_DIR}/cmake/LibIcal
+  PATH_VARS LIB_INSTALL_DIR INCLUDE_INSTALL_DIR
+)
+
+# Create a version file
+write_basic_package_version_file(
+  ${libical_BINARY_DIR}/LibIcalConfigVersion.cmake
+  VERSION ${LIBICAL_LIB_VERSION_STRING}
+  COMPATIBILITY SameMajorVersion
+)
+
+install(
+  FILES ${libical_BINARY_DIR}/LibIcalConfigVersion.cmake ${libical_BINARY_DIR}/LibIcalConfig.cmake
+  DESTINATION ${LIB_INSTALL_DIR}/cmake/LibIcal
+)
+
+install(
+  EXPORT icalTargets
+  DESTINATION ${LIB_INSTALL_DIR}/cmake/LibIcal
+  FILE LibIcalTargets.cmake
+)
