=== src/libical/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
-configure_file(${CMAKE_CURRENT_SOURCE_DIR}/icalversion.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/icalversion.h @ONLY)
+configure_file(
+  ${CMAKE_CURRENT_SOURCE_DIR}/icalversion.h.cmake
+  ${CMAKE_CURRENT_BINARY_DIR}/icalversion.h
+  @ONLY
+)
 
 include_directories(
   ${CMAKE_BINARY_DIR}
@@ -11,8 +15,8 @@
 if(WIN32)
   if(MSVC)
     add_definitions(-DBUILD_LIBICALDLL)
-  endif(MSVC)
-endif(WIN32)
+  endif()
+endif()
 
 configure_file(icalerror.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/icalerror.h)
 
@@ -132,10 +136,10 @@
 if(WIN32)
   set(TOPS "\"${CMAKE_SOURCE_DIR}\"")
   set(TOPB "\"${CMAKE_BINARY_DIR}\"")
-else(WIN32)
+else()
   set(TOPS "${CMAKE_SOURCE_DIR}")
   set(TOPB "${CMAKE_BINARY_DIR}")
-endif(WIN32)
+endif()
 
 add_custom_command(
   OUTPUT
@@ -156,13 +160,6 @@
   ${CMAKE_BINARY_DIR}/src/libical/ical.h
 )
 
-macro(_list_prefix _outvar _listvar _prefix)
-  set(${_outvar})
-  foreach(_item IN LISTS ${_listvar})
-    list(APPEND ${_outvar} ${_prefix}${_item})
-  endforeach()
-endmacro(_list_prefix)
-
 # GObject Introspection
 if(HAVE_INTROSPECTION)
   include(GObjectIntrospectionMacros)
@@ -170,17 +167,20 @@
   #set(INTROSPECTION_SCANNER_ARGS "--add-include-path=${CMAKE_CURRENT_SOURCE_DIR}")
   #set(INTROSPECTION_COMPILER_ARGS "--includedir=${CMAKE_CURRENT_SOURCE_DIR}")
 
-  set(libical_0_48_gir "libical")
-  set(libical_0_48_gir_VERSION "0.48")
+  set(LIB_VERSION ${LIBICAL_LIB_VERSION_STRING})
+  string(REPLACE "." "_" LIB_VERSION "${LIB_VERSION}")
+  string(REPLACE "-" "_" LIB_VERSION "${LIB_VERSION}")
+
+  set(libical_${LIB_VERSION}_gir "libical")
+  set(libical_${LIB_VERSION}_gir_VERSION ${LIBICAL_LIB_VERSION_STRING})
   set(INTROSPECTION_SCANNER_ARGS ${CMAKE_BINARY_DIR}/src/libical/ical.h)
-  set(libical_0_48_gir_LIBRARY "ical")
-  set(libical_0_48_gir_INCLUDES GObject-2.0)
-  get_directory_property(_tmp_includes ical_LIB_SRCS)
-  _list_prefix(_includes _tmp_includes "-L")
-  set(libical_0_48_gir_CFLAGS ${_includes})
-  set(libical_0_48_gir_LIBS ical)
-
-  list(APPEND INTROSPECTION_GIRS libical-0.48.gir)
+  set(libical_${LIB_VERSION}_gir_LIBRARY "ical")
+  set(libical_${LIB_VERSION}_gir_INCLUDES GObject-2.0)
+  set(_includes ${_includes} "-L${LIBRARY_OUTPUT_PATH}")
+  set(libical_${LIB_VERSION}_gir_CFLAGS ${_includes})
+  set(libical_${LIB_VERSION}_gir_LIBS ical)
+
+  list(APPEND INTROSPECTION_GIRS libical-${LIBICAL_LIB_VERSION_STRING}.gir)
 
   gir_add_introspections(INTROSPECTION_GIRS)
 endif()
@@ -254,11 +254,13 @@
 if(WIN32)
   if(MSVC)
     list(APPEND ical_LIB_SRCS ../ical.def)
-  endif(MSVC)
-endif(WIN32)
+  endif()
+endif()
 
 add_library(ical ${LIBRARY_TYPE} ${ical_LIB_SRCS})
-add_library(ical-static STATIC ${ical_LIB_SRCS})
+if(NOT SHARED_ONLY)
+  add_library(ical-static STATIC ${ical_LIB_SRCS})
+endif()
 
 add_dependencies(ical ical-header)
 
@@ -266,22 +268,39 @@
 
 if(WINCE)
   target_link_libraries(ical ${WCECOMPAT_LIBRARIES})
-endif(WINCE)
+endif()
 
 if(MSVC)
   set_target_properties(ical PROPERTIES OUTPUT_NAME "libical")
-  set_target_properties(ical-static PROPERTIES OUTPUT_NAME "libical-static")
-else(MSVC)
-  set_target_properties(ical-static PROPERTIES OUTPUT_NAME "ical")
-endif(MSVC)
+  if(NOT SHARED_ONLY)
+    set_target_properties(ical-static PROPERTIES OUTPUT_NAME "libical-static")
+  endif()
+else()
+  if(NOT SHARED_ONLY)
+    set_target_properties(ical-static PROPERTIES OUTPUT_NAME "ical")
+  endif()
+endif()
 set_target_properties(ical PROPERTIES
   VERSION ${LIBICAL_LIB_VERSION_STRING}
   SOVERSION ${LIBICAL_LIB_MAJOR_VERSION}
 )
 set_target_properties(ical PROPERTIES CLEAN_DIRECT_OUTPUT 1)
-set_target_properties(ical-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
-
-install(TARGETS ical ical-static ${INSTALL_TARGETS_DEFAULT_ARGS})
+if(NOT SHARED_ONLY)
+  set_target_properties(ical-static PROPERTIES CLEAN_DIRECT_OUTPUT 1)
+endif()
+
+install(
+  TARGETS ical
+  EXPORT icalTargets
+  DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS}
+)
+if(NOT SHARED_ONLY)
+  install(
+    TARGETS ical-static
+    EXPORT icalTargets
+    DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS}
+  )
+endif()
 
 ########### install files ###############
