=== debian/changelog ===
libical (1.0.1-0ubuntu2) xenial; urgency=medium

  * Multiarchify the library packages.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 28 Jan 2016 15:32:14 +0100

libical (1.0.1-0ubuntu1) wily; urgency=medium

  * New upstream release
  * debian/docs:
  * debian/libical1a.docs:
    - Update for new docs
  * debian/libical1a.symbols:
    - Updated
  * debian/patches/reproducible-generator.patch:
    - Applied upstream

 -- Robert Ancell <robert.ancell@canonical.com>  Wed, 17 Jun 2015 12:08:36 +1200

libical (1.0-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libical1 to libical1a because the change introduced in the previous
    upload breaks compatibility. (Closes: #774242)

 -- Ivo De Decker <ivodd@debian.org>  Sat, 03 Jan 2015 14:58:46 +0100

libical (1.0-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Sort keys to generate reproducible source code. (Closes: #773916)

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Mon, 29 Dec 2014 18:42:22 +0000

libical (1.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add missing license information to debian/copyright.
    (Closes: #738967)

 -- Tobias Hansen <thansen@debian.org>  Sun, 19 Oct 2014 00:28:41 +0200

libical (1.0-1) unstable; urgency=medium

  * New upstream release (Closes: #717417)
  * Remove patches - merged upstream:
    - 0001_convert_float_to_strings_with_snprintf_sfbug3493034.patch
    - fix_arm_ftbfs.patch
    - fix_ftbfs_dependencies.patch
  * Update debian/control:
    - bump soname (libical0 -> libical1)
    - bump Standards-Version to 3.9.5 (no changes needed)

 -- Fathi Boudra <fabo@debian.org>  Sun, 09 Feb 2014 12:05:44 +0200
