=== debian/control ===
Source: libical
Section: libs
Priority: optional
Maintainer: Fathi Boudra <fabo@debian.org>
Build-Depends: cmake, debhelper (>= 9), tzdata
Standards-Version: 3.9.5
Homepage: http://freeassociation.sourceforge.net

Package: libical-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libical1a (= ${binary:Version}), ${misc:Depends}
Description: iCalendar library implementation in C (development)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.

Package: libical1a
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: tzdata, ${misc:Depends}, ${shlibs:Depends}
Breaks: libical1
Replaces: libical1
Description: iCalendar library implementation in C (runtime)
 libical is an open source implementation of the IETF's iCalendar calendaring
 and scheduling protocols (RFC 2445, 2446, and 2447). It parses iCal components
 and provides a C API for manipulating the component properties, parameters,
 and subcomponents.
 .
 This package contains the files necessary for running applications that use
 the libical library.

Package: libical-dbg
Priority: extra
Architecture: any
Multi-Arch: same
Section: debug
Depends: libical1a (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for libical
 This package contains the debugging symbols associated with libical.
 .
 They will automatically be used by gdb for debugging libical related issues.
