=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=cmake --parallel --list-missing --dbg-package=libical-dbg

override_dh_install:
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/lib* debian/tmp/usr/lib/pkgconfig \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	dh_install
